/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012 Meika Sugimoto
 *  Copyright (C) 2013-2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 * åȰ¸⥸塼(LPCXPRESSO-LPC812)
 */
#include "kernel_impl.h"
#include <sil.h>
#include "target_serial.h"
#include "target_syssvc.h"

/*
 * åȥƥΥϡɥ񸻤
 */
#include "lpcxpresso_lpc812.h"

/*
 * MTB buffer
 */
#ifdef __USE_MTB
#include <cr_mtb_buffer.h>
__CR_MTB_BUFFER(__MTB_BUF_SIZE);
#endif
                    /*
 * åȰ¸
 */
void target_initialize(void)
{
	/*
	 *  ץå¸ν
	 */
	prc_initialize();

	/*
	 *  I/OݡȤν
	 */
#if (SIO_PORTID == 1)
	volatile uint32_t tmp;

	tmp = sil_rew_mem((void *)TADR_SWM_PINASSIGN0);
	tmp &= ~(0xFF << 0);
	tmp |= (4 << 0);	// P0.4 is UART0 TXD
	tmp &= ~(0xFF << 8);
	tmp |= (0 << 8);	// P0.0 is UART0 RXD
	sil_wrw_mem((void *)TADR_SWM_PINASSIGN0, tmp);
#endif

	/*
	 *  ХʡѤΥꥢ
	 */
	target_low_output_init(SIO_PORTID);
	sil_dly_nse(10 * 1000 * 1000);
}

/*
 * åȰ¸ λ
 */
void NoReturn target_exit(void)
{
	/* ץå¸νλ */
	prc_terminate();
}

/*
 * ƥ٥ϤΤʸ
 */
void target_fput_log(char c)
{
	if (c == '\n') {
		sio_pol_snd_chr('\r', SIO_PORTID);
	}
	sio_pol_snd_chr(c, SIO_PORTID);
}


